/* LABORATORIO DI ALGORITMI
	
	gruppo LAUREA 01
	
	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828
*/




#include "heap.h"
typedef heap coda;

status makecoda(coda *c, int n);
/* Inizializza in *c una coda vuota che puo' contenere fino a n elementi;
rstituisce un valore status a seconda che l'operazione sia
andata a buon fine o no*/

bool test_vuota(coda c);
/* Controlla se c e' vuota*/

status codainsert(coda *c, dato d);
/* Inserisce il dato d in *c; restituisce un valore status a seconda che
l'operazione sia andata a buon fine o no*/

status codaextractmin(coda *c, dato *d);
/* Estrae il minimo della coda *c che viene letto in *d e restituisce
un valore status a seconda che l'operazione sia andata a buon fine o no*/

status min(coda c, dato *d);
/* Legge il minimo della coda che viene letto in *d senza modificare la coda;
restituisce un valore status a seconda che l'operazione sia andata a buon
fine oppure no */

bool update( coda *c, dato d, int nuovapriorita);
/* Aggiorna la priorita' dell'elemento dato della coda a nuovapriorita'
se questa e' strettamente inferiore a quella di dato. Restituisce un valore
booleano per indicare se la sostituzione e' avvenuta o no*/

void destroy(coda *c);
/* Distruggi la coda*/

void print(coda c);
/* Stampa il contenuto della coda c*/