/* LABORATORIO DI ALGORITMI

	gruppo LAUREA 01

	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828
*/

#include <stdio.h>
#include "heap.h"
#include "code.h"
#include <conio.h>
#include <stdlib.h>
#include <string.h>
void main()
{
heap a;
dato d;
int i,k;

clrscr();
if (makeheap(&a,10)==error)    // Alloca lo spazio per un Heap di 10 elementi
	printf("Non ce l'ho fatta ad allocare spazio in memoria!!!\n");
printf("Come e' l'heap?\n");
if (test_vuoto(a))		// Test di test_vuoto()
	printf("Heap Vuoto\n");
else
	printf("Heap Pieno\n");
getchar();

for (i =0; i< MAXELEM ; i++) // Assegna i nomi e le priorita agli elementi  del vettore allocato
	{
	d=malloc(sizeof( struct elem ));
	d->nome=malloc(13);
	strcpy(d->nome,"Processo N. ");
	d->nome[11]='0'+i;
	d->priorita=100-i*10;
	inserisci(&a,d);
	}
printf("Ho inserito, con INSERISCI, degli elementi nel vettore...\n");
stampa(a);   // stampa il vettore prima di Heapify()
printf("Per rimescolare gli elementi...\n");
printf("...scambio il processo 0 col 4, il 9 col 2 ed il 7 con 1 utilizzando la Swap\n");
printf("Premi invio per continuare\n");
getchar();
swap(&a,0,4);		// Rimescoliamo l'Heap per testare swap e Heapify
swap(&a,9,2);
swap(&a,7,1);
clrscr();
printf("Ecco il vettore rimescolato\n");
stampa(a);
printf("Premi invio per continuare\n");
getchar();
printf("Ritestiamo Test_vuoto... Come e' l'heap, scusa???\n");
if(test_vuoto(a))               //Ritesto Test_vuoto
	printf("Heap Vuoto\n");
else
	printf("Heap Pieno\n");
getchar();
clrscr();
printf("Ora trasformo il vettore in Heap\n");
if (buildheap(&a)==ok)             	// Trasforma il Vettore In Heap
	{
	printf("Ecco l'Heap...\n");
	stampa(a);
	getchar();
	clrscr();
	printf("Ora estraggo il minimo\n");
	if (estrai_minimo(&a,&d)==error)
	       {
	       printf("Non sono riuscito ad estrarre il minimo...Addio!\n");
	       exit(1);			// Test di Estrai Minimo
	       }
	printf("L' elemento minimo dell' Heap e' %s con Priorita %d\n",d->nome,d->priorita);
	printf("Questo e' il nuovo heap\n");
	stampa(a);
	getchar();
	printf("Inserisci l'indice del nodo da aggiornare\n"); // test di aggiorna()
	scanf("%d",&i);
	if (i<MAXELEM)
		{
		printf("Immetti la nuova priorita per %s\n",a.vettore[i]->nome);
		scanf("%d",&k);
		aggiorna(&a,i,k);           	// Test di Aggiorna
		stampa(a);
		}
	else
		{
		printf("Mi dispiace, hai inserito un indice non valido...\n");
		printf("Rischiavi di farmi fare un bel po' di casino!!!\n");
		getchar();
		}
	printf("Sto per distruggere tutto e liberare memoria...\n");
	sleep(4);
	distruggi(&a);
	}
}
