/* LABORATORIO DI ALGORITMI
	
	gruppo LAUREA 01
	
	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828

FILE FIFO.C

	Implementa le funzioni relative al tipo coda fifo

*/


#include <stdlib.h>
#include "fifo.h"
#include "liste.h"
#include "local.h"

status crea_coda_vuota(fifo *p_F)
{
	*p_F=(fifo)malloc(sizeof( struct coda_fifo));
	
	if (p_F == NULL)
		return error;	
	(*p_F)->coda=NULL;
	return makelista(&(*p_F)->testa);
}


bool   controlla_coda_vuota(fifo F)
{
if ( F->testa==NULL)
return TRUE;
return FALSE;
}


status testa_della_coda(fifo F, dato *p_elem)

{
	if( controlla_coda_vuota(F)==TRUE)
		return error;
	*p_elem=F->testa->elem;
	return ok;
}


status inserisci(fifo *p_F, dato elem)
{ 
	if (controlla_coda_vuota(*p_F)==TRUE)
		if (inserisci_in_testa(&(*p_F)->coda,elem)== error)
			return error;
		else
		{
			(*p_F)->testa=(*p_F)->coda;
			return ok;
		}
	if (inserisci_in_testa(&(*p_F)->coda->next,elem)== error)
		return error;
	else
		(*p_F)->coda=(*p_F)->coda->next;
	return ok;
	
}


status estrai_testa(fifo *p_F, dato *p_elem)
{
	if( controlla_coda_vuota(*p_F)==TRUE)
		return error;
	cancella_in_testa (&(*p_F)->testa, p_elem);
	if( controlla_coda_vuota(*p_F)==TRUE)
		(*p_F)->coda=NULL;
		return ok;

}



void distruggi_coda(fifo *p_F)
{

cancella_lista(&(*p_F)->testa);	
free(*p_F);
}

