/* LABORATORIO DI ALGORITMI
	
	gruppo LAUREA 01
	
	Cascio Vittorio 	st950339
	Manca Maurizio		st970729
	Borello Andrea		st970828
*/



#include "code.h"
#include "heap.h"
#include "local.h"


status makecoda(coda *c, int n)
/* Inizializza in *c una coda vuota che puo' contenere fino a n elementi;
restituisce un valore status a seconda che l'operazione sia
andata a buon fine o no*/
{
return makeheap(c,n);
}

bool test_vuota(coda c)
/* Controlla se c e' vuota*/
{
return test_vuoto(c);
}
status codainsert(coda *c, dato d)
/* Inserisce il dato d in *c; restituisce un valore status a seconda che
l'operazione sia andata a buon fine o no*/
{
return 	inserisci(c,d);
}

status codaextractmin(coda *c, dato *d)
/* Estrae il minimo della coda *c che viene letto in *d e restituisce
un valore status a seconda che l'operazione sia andata a buon fine o no*/
{
return estrai_minimo(c,d);
}

status min(coda c, dato *d)
/* Legge il minimo della coda che viene letto in *d senza modificare la coda;
restituisce un valore status a seconda che l'operazione sia andata a buon
fine oppure no */
{
	return minimo(c,d);
}

bool update( coda *c, dato d, int nuovapriorita)
/* Aggiorna la priorita' dell'elemento dato della coda a nuovapriorita'
se questa e' strettamente inferiore a quella di dato. Restituisce un valore
booleano per indicare se la sostituzione e' avvenuta o no*/
{
int i;
i= find( *c,d);
if (i >=0)
	return aggiorna(c,i,nuovapriorita);
return FALSE;

}

void destroy(coda *c)
/* Distruggi la coda*/
{
distruggi(c);
}

void print(coda c)
/* Stampa il contenuto della coda c*/
{
stampa(c);
}
